--https://docs.microsoft.com/en-us/sql/relational-databases/system-dynamic-management-views/sys-dm-db-index-operational-stats-transact-sql?view=sql-server-2017

--Demo all columns
	USE AdventureWorks2014

	SELECT *
	FROM sys.dm_db_index_operational_stats( DB_ID('adventureworks2014'), 1237579447, NULL, NULL);    
	GO

--Demo this statement
--Show indexes on the HumanResources.Employee table

	SELECT 
		  object_id
		, range_scan_count 
		, index_id
		, singleton_lookup_count
	FROM sys.dm_db_index_operational_stats( DB_ID('adventureworks2014'), 1237579447, NULL, NULL);    
	GO

--Demo to confirm the object name
	SELECT * 
	FROM sysobjects
	WHERE id = 1237579447
	
	SELECT
		index_id,
		name AS Index_Name,
		type_desc  As Index_Type,
		is_unique,
		OBJECT_NAME(object_id) As Table_Name
	FROM
		sys.indexes
	WHERE
		is_hypothetical = 0 AND
		index_id != 0 AND
		object_id = OBJECT_ID('humanresources.employee');

--Run the with Actual Execution plan turned on, show the scan
	USE AdventureWorks2014
	SELECT * 
	FROM HumanResources.Employee

--This will use a seek
	Use AdventureWorks2014

--Will return a single row, singleton_lookup_count

	SELECT * 
	FROM HumanResources.Employee e
	WHERE e.BusinessEntityID = 5
