PRINT '========================================================================================================================='
PRINT ''
PRINT ''
PRINT 'Percent of Cache that is Ad Hoc Queries'
PRINT ''
PRINT ''
PRINT ''

--https://blog.sqlauthority.com/2017/10/20/sql-server-turn-optimize-ad-hoc-workloads/
--Pinal Dave

SELECT 'Percent of Cache - Ad Hoc Queries' AS 'Status',
		AdHoc_Plan_MB, Total_Cache_MB,
		AdHoc_Plan_MB*100.0 / Total_Cache_MB AS 'AdHoc %'
FROM (
SELECT SUM(CASE
			WHEN objtype = 'adhoc'
			THEN CONVERT(BIGINT,size_in_bytes)
			ELSE 0 END) / 1048576.0 AdHoc_Plan_MB,
		SUM(CONVERT(BIGINT,size_in_bytes)) / 1048576.0 Total_Cache_MB
FROM sys.dm_exec_cached_plans) T