		

		-- run in a new connection

		USE AdventureWorks2014

		BEGIN TRAN
		UPDATE Person.Person SET Suffix = 'B' 
		WHERE BusinessEntityID < 20

		--Make sure to rollback

		ROLLBACK

		USE AdventureWorks2014

		--Run with out the NOLOCK then with the NOLOCK
		--Notice Suffix is all "B"
		SELECT * 
		FROM Person.Person  WITH (NOLOCK)
		WHERE BusinessEntityID < 20

		SET TRANSACTION ISOLATION LEVEL READ UNCOMMITTED
		SELECT * 
		FROM Person.Person 
		WHERE BusinessEntityID< 20

		--Run this to show types of locks aquired
		--Move to excel and show number of X locks compared to number of rows modified
		sp_lock

		--Might return more rows than expected, look at the request_session_id
		SELECT * 
		FROM sys.dm_tran_locks
		WHERE request_mode = 'x'



		--Will not work because in range of current update
		SET TRANSACTION ISOLATION LEVEL READ COMMITTED
		SELECT * 
		FROM Person.Person  

		--Will work because not in range of the update
		--Notice Suffix is not a B
		SET TRANSACTION ISOLATION LEVEL READ COMMITTED
		SELECT * 
		FROM Person.Person  
		WHERE BusinessEntityID > 220