	--Insert data and create fragmentation
	--Demo Idera Fragmentation Analyzer

		--Fragmentation for all database indexes
		SELECT DB_ID(database_id) AS 'DatabaseName',*
		FROM sys.dm_db_index_physical_stats (Null, NULL, NULL, NULL, NULL) i
		where avg_fragmentation_in_percent > 30 
		GO 


		--Run this for a specific database
		USE Adventureworks2014


		CREATE TABLE #TempTableRowCounts
					(SchemaName VARCHAR(50)
					 , TableName VARCHAR(200)
					 , TotalRowCOunt BIGINT)
				INSERT #TempTableRowCounts
					SELECT  SCHEMA_NAME(schema_id),
							t.name,
							SUM(p.[rows]) AS [TotalRowCount]
					FROM sys.tables AS t
						INNER JOIN sys.partitions AS p
							ON t.object_id = p.object_id
								--AND p.index_id IN ( 0, 1 )
					GROUP BY SCHEMA_NAME(schema_id), t.name;


		SELECT 
				  i.Database_ID
				, i.Object_id
				, s.name
				, i.Index_Id
				, i.partition_number
				, i.index_type_desc
				, r.TotalRowCOunt
				, i.avg_fragmentation_in_percent
		FROM sys.dm_db_index_physical_stats (Null, NULL, NULL, NULL, NULL) i
				INNER JOIN sysobjects s
					ON i.object_id = s.id
				LEFT OUTER JOIN #TempTableRowCounts r
					ON s.name = r.TableName COLLATE DATABASE_DEFAULT
		WHERE 
				avg_fragmentation_in_percent > 30  AND
				database_id = 16 --Include if looking for a specific database
		--order by avg_fragmentation_in_percent desc


		DROP TABLE #TempTableRowCounts
		GO 
		
		--==============================================

		TRUNCATE TABLE [dbo].[TestFragmentation]


		--Then run the fragmentation code to confirm fragmentation is  empty
		SELECT COUNT(*) 
		FROM [dbo].[TestFragmentation]


		--Run this code to create fragmentation
		--Stop after a few minutes
		DECLARE @counter SMALLINT;  
		SET @counter = 1;  
		WHILE @counter < 10000
		   BEGIN  
			INSERT TestFragmentation
				(ID, TestFragString)
				Values
				( @counter
				  , CONVERT(varchar(255), NEWID()))
			  SET @counter = @counter + 1  
		   END;  
		GO 
		--Then run the code to confirm fragmentation NOT 0

		--Returns Fragementation percent
		SELECT a.index_id, name, avg_fragmentation_in_percent  
		FROM sys.dm_db_index_physical_stats (DB_ID(N'AdventureWorks2014'), 
				OBJECT_ID(N'dbo.TestFragmentation'), NULL, NULL, NULL) AS a  
			INNER JOIN sys.indexes AS b 
				ON a.object_id = b.object_id 
					AND a.index_id = b.index_id;  

			--Defrag All Indexes on a table
			--After each, run the above fragmentation percent query
			ALTER INDEX ALL ON dbo.testfragmentation 
			REORGANIZE ;   
			GO  

			ALTER INDEX ALL ON dbo.testfragmentation 
			REBUILD ;   
			GO 

			--Defrag for a specific index
			ALTER INDEX [NonClusteredIndex-20180503-225313] ON [dbo].[TestFragmentation]
			REBUILD;