--http://www.sqlservercentral.com/blogs/basits-sql-server-tips/2012/07/19/using-cell-level-encryption-in-sql-server/

CREATE MASTER KEY ENCRYPTION BY PASSWORD  = '$tr0nGPa$$w0rd' 
GO

CREATE ASYMMETRIC KEY MyAsymmetricKey 
    WITH ALGORITHM = RSA_2048
    ENCRYPTION BY PASSWORD  = '$e1ectPa$$w0rd'
GO

SELECT * FROM [sys].[asymmetric_keys] 
GO


CREATE SYMMETRIC KEY MySymmetricKey
    WITH ALGORITHM = AES_256  
    ENCRYPTION BY ASYMMETRIC KEY MyAsymmetricKey
GO

SELECT * FROM [sys].[symmetric_keys] 
GO

-- Opening the symmetric key
OPEN SYMMETRIC KEY MySymmetricKey
DECRYPTION BY ASYMMETRIC KEY MyAsymmetricKey 
WITH PASSWORD  = '$e1ectPa$$w0rd'
GO

SELECT * FROM [sys].[openkeys]
GO



CREATE TABLE TestEncryptionPassphrase
([Name]                            [varchar] (256)
,[CreditCardNumber]                [varchar](16)
,[EncryptedCreditCardNumber]       [varbinary](max))
GO

INSERT INTO TestEncryptionPassphrase ([Name], [CreditCardNumber])
SELECT 'Simon Jones', '9876123456782378'
UNION ALL
SELECT 'Kim Brian', '1234567898765432'
GO

SELECT * FROM TestEncryptionPassphrase
GO

CREATE TABLE TestEncryptionPassAsymmetric
([Name]                            [varchar] (256)
,[CreditCardNumber]                [varchar](16)
,[EncryptedCreditCardNumber]       [varbinary](max))
GO

INSERT INTO TestEncryptionPassAsymmetric ([Name], [CreditCardNumber])
SELECT 'Simon Jones', '9876123456782378'
UNION ALL
SELECT 'Kim Brian', '1234567898765432'
GO

SELECT * FROM TestEncryptionPassAsymmetric
GO

CREATE TABLE TestEncryptionPassSymmetric
([Name]                            [varchar] (256)
,[CreditCardNumber]                [varchar](16)
,[EncryptedCreditCardNumber]       [varbinary](max))
GO

INSERT INTO TestEncryptionPassSymmetric ([Name], [CreditCardNumber])
SELECT 'Simon Jones', '9876123456782378'
UNION ALL
SELECT 'Kim Brian', '1234567898765432'
GO

SELECT * FROM TestEncryptionPassSymmetric
GO

CREATE TABLE TestEncryptionPassCert
([Name]                            [varchar] (256)
,[CreditCardNumber]                [varchar](16)
,[EncryptedCreditCardNumber]       [varbinary](max))
GO

INSERT INTO TestEncryptionPassCert ([Name], [CreditCardNumber])
SELECT 'Simon Jones', '9876123456782378'
UNION ALL
SELECT 'Kim Brian', '1234567898765432'
GO

SELECT * FROM TestEncryptionPassCert
GO



--As you can see we are using ENCRYPTBYKEY function to encrypt the column values
UPDATE [dbo].[TestEncryptionPassphrase]
SET [EncryptedCreditCardNumber] = ENCRYPTBYKEY(KEY_GUID('MySymmetricKey'), CreditCardNumber)
GO


SELECT Name, CreditCardNumber, CONVERT([varchar](16), DECRYPTBYKEY(EncryptedCreditCardNumber))
 FROM [dbo].[TestEncryptionPassphrase]
GO


-- Creating symmetric key encrypted by password
CREATE SYMMETRIC KEY MySymmetricKeyPwd
    WITH ALGORITHM = AES_256    
    ENCRYPTION BY PASSWORD = 'RememberMe!' 
GO

-- Opening the symmetric key
OPEN SYMMETRIC KEY MySymmetricKeyPwd
DECRYPTION BY PASSWORD = 'RememberMe!' 
GO



--As you can see we are using ENCRYPTBYKEY function to encrypt the column values
UPDATE [dbo].[TestEncryptionPassSymmetric]
SET [EncryptedCreditCardNumber] = ENCRYPTBYKEY(KEY_GUID('MySymmetricKey'), CreditCardNumber)
GO

SELECT * FROM [dbo].[TestEncryptionPassSymmetric]

SELECT *, CONVERT([varchar](16), DECRYPTBYKEY(EncryptedCreditCardNumber))
FROM [dbo].[TestEncryptionPassSymmetric]