--https://solutioncenter.apexsql.com/top-sql-server-memory-pressure-counters/
--https://blogs.technet.microsoft.com/sqlpilot/2011/02/14/memory-pressure-and-how-to-see-it/

SELECT [cntr_value], 'Cach Hit Ratio'
FROM sys.dm_os_performance_counters
WHERE
	[object_name] LIKE '%Buffer Manager%'
	AND [counter_name] = 'Buffer cache hit ratio'

	SELECT [cntr_value], 'PLE'
FROM sys.dm_os_performance_counters
WHERE
	[object_name] LIKE '%Buffer Manager%'
	AND [counter_name] = 'Page life expectancy'


	SELECT [cntr_value], 'Memory Grants Pending'
FROM sys.dm_os_performance_counters
WHERE
	[object_name] LIKE '%Memory Manager%'
	AND [counter_name] = 'Memory Grants Pending'



	--System Memory Usage 

SELECT  

    EventTime, 

    record.value('(/Record/ResourceMonitor/Notification)[1]', 'varchar(max)') as [Type], 

    record.value('(/Record/ResourceMonitor/IndicatorsProcess)[1]', 'int') as [IndicatorsProcess], 

    record.value('(/Record/ResourceMonitor/IndicatorsSystem)[1]', 'int') as [IndicatorsSystem], 

    record.value('(/Record/MemoryRecord/AvailablePhysicalMemory)[1]', 'bigint') AS [Avail Phys Mem, Kb], 

    record.value('(/Record/MemoryRecord/AvailableVirtualAddressSpace)[1]', 'bigint') AS [Avail VAS, Kb] 

FROM ( 

    SELECT 

        DATEADD (ss, (-1 * ((cpu_ticks / CONVERT (float, ( cpu_ticks / ms_ticks ))) - [timestamp])/1000), GETDATE()) AS EventTime, 

        CONVERT (xml, record) AS record 

    FROM sys.dm_os_ring_buffers 

    CROSS JOIN sys.dm_os_sys_info 

    WHERE ring_buffer_type = 'RING_BUFFER_RESOURCE_MONITOR') AS tab 

ORDER BY EventTime DESC;
