/*==================================================================

Session Prep

- Run Delete statistics script

====================================================================*/

--Demo #1
--Auto Create Stats on Unit Price Column
--Show table stats

		USE [AdventureWorks2014]
		DROP STATISTICS sales.[SalesOrderDetail]._WA_Sys_00000006_44CA3770
		DROP STATISTICS sales.[SalesOrderDetail]._WA_Sys_00000007_44CA3770
		DROP STATISTICS sales.[SalesOrderDetail]._WA_Sys_00000008_44CA3770
		DROP STATISTICS sales.[SalesOrderDetail].[DiscAndUnitPrice]
		--Will create stats
		SELECT *
		FROM [Sales].[SalesOrderDetail]
		WHERE UnitPrice > 4

--===================================================================

--Demo 2A
	
	UPDATE STATISTICS Production.Product([MakeFlag])  
    WITH FULLSCAN
	--Run this first, then run above then run again
	--Note MakeFlag update time
	SELECT OBJECT_NAME(object_id) AS [ObjectName]
		  ,[name] AS [StatisticName]
		  ,STATS_DATE([object_id], [stats_id]) AS [StatisticUpdateDate]
	FROM sys.stats
	ORDER BY 3 DESC
--======================================================
--Demo #3
		--Turn on or off for a table
		EXEC sp_autostats 'Production.Product', 'OFF';  
		GO 

		EXEC sp_autostats 'Production.Product', 'ON', AK_Product_Name;  
		GO  

		EXEC sp_autostats 'Production.Product';  
		GO

--=======================================================
--Demo #5

--Get Statistics Information
		ALTER DATABASE AdventureWorks2014
		SET AUTO_CREATE_STATISTICS ON
		GO

		--String Stats
		DBCC SHOW_STATISTICS('production.product',StatsProductName)
			--Rows and Rows Sampled
			SELECT COUNT(*)
			FROM production.product
			--Range_Rows
			SELECT *
			FROM production.product
			WHERE Name BETWEEN 'Adjustable Race' and 'BB Ball Bearing'
			ORDER BY Name
			--EQ_Rows
			SELECT *
			FROM production.product
			WHERE Name = 'BB Ball Bearing'
		--Filtered
		DBCC SHOW_STATISTICS('production.product',ReorderPoint)WITH density_vector
		--No-Filter
		DBCC SHOW_STATISTICS('production.product',ReorderPointNoFilter)WITH density_vector
		--Histogram
		DBCC SHOW_STATISTICS('person.person',[IX_Person_LastName_FirstName_MiddleName]) WITH HISTOGRAM
		--Header, Density Vector, Histogram
		DBCC SHOW_STATISTICS('person.person',[IX_Person_LastName_FirstName_MiddleName]) WITH density_vector
		--Show All Density column in Density Vector

		

		SELECT  so.name,
				st.name,
				st.stats_id,
				sc.stats_column_id,
				c.name as column_name,
				st.auto_created,
				st.filter_definition,
				sp.last_updated,
				sp.rows,
				sp.rows_sampled,
				sp.steps,
				sp.modification_counter
		FROM sys.stats AS st
			INNER JOIN sys.stats_columns AS sc 
				ON st.object_id=sc.object_id 
					AND st.stats_id=sc.stats_id
			INNER JOIN sys.columns AS c 
				ON sc.object_id=c.object_id 
					AND sc.column_id=c.column_id
			INNER JOIN sys.objects AS so 
				ON st.object_id=so.object_id
			CROSS APPLY sys.dm_db_stats_properties(st.object_id, st.stats_id) sp
		order by last_updated desc
--Is auto create stats turn on?
		SELECT	  Name
				, database_id
				, is_auto_create_stats_on 
		FROM sys.databases

--Object and Column information
		SELECT OBJECT_NAME(s.object_id) AS object_name,  
			COL_NAME(sc.object_id, sc.column_id) AS column_name,  
			s.name AS statistics_name  
		FROM sys.stats AS s 
		INNER JOIN sys.stats_columns AS sc  
			ON s.stats_id = sc.stats_id 
				AND s.object_id = sc.object_id  
		WHERE s.name like '_WA%'  
		ORDER BY s.name;  