IF EXISTS(SELECT * FROM sys.server_event_sessions WHERE name='TraceToEE')
   DROP EVENT SESSION TraceToEE ON SERVER;
CREATE EVENT SESSION TraceToEE
ON SERVER
    ADD EVENT sqlserver.database_file_size_change     (ACTION        (      sqlserver.client_app_name, sqlserver.client_hostname, sqlserver.client_pid, sqlserver.database_id, sqlserver.database_name,  sqlserver.is_system, sqlserver.nt_username, sqlserver.server_instance_name, sqlserver.server_principal_name, sqlserver.server_principal_sid, sqlserver.session_id, sqlserver.session_server_principal_name)      ),
    ADD EVENT sqlserver.database_mirroring_state_change     (ACTION        (      sqlserver.database_id, sqlserver.database_name,  sqlserver.is_system, sqlserver.request_id, sqlserver.server_instance_name, sqlserver.server_principal_sid, sqlserver.session_id, sqlserver.session_server_principal_name, sqlserver.transaction_id)      ),
    ADD EVENT sqlserver.errorlog_written     (ACTION        (      sqlserver.client_app_name, sqlserver.client_hostname, sqlserver.client_pid, sqlserver.database_id, sqlserver.database_name, sqlserver.is_system, sqlserver.nt_username, sqlserver.request_id, sqlserver.server_instance_name, sqlserver.server_principal_name, sqlserver.server_principal_sid, sqlserver.session_id, sqlserver.session_server_principal_name, sqlserver.transaction_id)      ),
    ADD EVENT sqlserver.full_text_crawl_started     (ACTION        (      sqlserver.database_id, sqlserver.is_system, sqlserver.server_instance_name, sqlserver.session_id, sqlserver.session_server_principal_name, sqlserver.transaction_id)      ),
    ADD EVENT sqlserver.full_text_crawl_stopped     (ACTION        (      sqlserver.database_id,  sqlserver.is_system, sqlserver.server_instance_name, sqlserver.session_id, sqlserver.session_server_principal_name, sqlserver.transaction_id)      ),
    ADD EVENT sqlserver.hash_warning     (ACTION        (      sqlserver.client_app_name, sqlserver.client_hostname, sqlserver.client_pid, sqlserver.database_id, sqlserver.database_name,  sqlserver.is_system, sqlserver.nt_username, sqlserver.request_id, sqlserver.server_instance_name, sqlserver.server_principal_name, sqlserver.server_principal_sid, sqlserver.session_id, sqlserver.session_resource_group_id, sqlserver.session_server_principal_name, sqlserver.transaction_id, sqlserver.transaction_sequence)      ),
    ADD EVENT sqlserver.missing_column_statistics     (ACTION        (      sqlserver.client_app_name, sqlserver.client_hostname, sqlserver.client_pid, sqlserver.database_id, sqlserver.database_name,  sqlserver.is_system, sqlserver.nt_username, sqlserver.request_id, sqlserver.server_instance_name, sqlserver.server_principal_name, sqlserver.server_principal_sid, sqlserver.session_id, sqlserver.session_resource_group_id, sqlserver.session_server_principal_name, sqlserver.transaction_id, sqlserver.transaction_sequence)      ),
    ADD EVENT sqlserver.missing_join_predicate     (ACTION        (      sqlserver.client_app_name, sqlserver.client_hostname, sqlserver.client_pid, sqlserver.database_id, sqlserver.database_name,  sqlserver.is_system, sqlserver.nt_username, sqlserver.request_id, sqlserver.server_instance_name, sqlserver.server_principal_name, sqlserver.server_principal_sid, sqlserver.session_id, sqlserver.session_resource_group_id, sqlserver.session_server_principal_name, sqlserver.transaction_id, sqlserver.transaction_sequence)      ),
    ADD EVENT sqlserver.object_altered     (ACTION        (      sqlserver.client_app_name, sqlserver.client_hostname, sqlserver.client_pid, sqlserver.database_id, sqlserver.database_name,  sqlserver.is_system, sqlserver.nt_username, sqlserver.request_id, sqlserver.server_instance_name, sqlserver.server_principal_name, sqlserver.server_principal_sid, sqlserver.session_id, sqlserver.session_resource_group_id, sqlserver.session_server_principal_name, sqlserver.transaction_id, sqlserver.transaction_sequence)      ),
    ADD EVENT sqlserver.object_created     (ACTION        (      sqlserver.client_app_name, sqlserver.client_hostname, sqlserver.client_pid, sqlserver.database_id, sqlserver.database_name,  sqlserver.is_system, sqlserver.nt_username, sqlserver.request_id, sqlserver.server_instance_name, sqlserver.server_principal_name, sqlserver.server_principal_sid, sqlserver.session_id, sqlserver.session_resource_group_id, sqlserver.session_server_principal_name, sqlserver.transaction_id, sqlserver.transaction_sequence)      ),
    ADD EVENT sqlserver.object_deleted     (ACTION        (      sqlserver.client_app_name, sqlserver.client_hostname, sqlserver.client_pid, sqlserver.database_id, sqlserver.database_name,  sqlserver.is_system, sqlserver.nt_username, sqlserver.request_id, sqlserver.server_instance_name, sqlserver.server_principal_name, sqlserver.server_principal_sid, sqlserver.session_id, sqlserver.session_resource_group_id, sqlserver.session_server_principal_name, sqlserver.transaction_id, sqlserver.transaction_sequence)      ),
    ADD EVENT sqlserver.plan_guide_unsuccessful     (ACTION        (      sqlserver.client_app_name, sqlserver.client_hostname, sqlserver.client_pid, sqlserver.database_id, sqlserver.database_name,  sqlserver.is_system, sqlserver.nt_username, sqlserver.request_id, sqlserver.server_instance_name, sqlserver.server_principal_name, sqlserver.server_principal_sid, sqlserver.session_id, sqlserver.session_server_principal_name, sqlserver.transaction_id, sqlserver.transaction_sequence)      ),
    ADD EVENT sqlserver.server_memory_change     (ACTION        (       sqlserver.is_system, sqlserver.request_id, sqlserver.server_instance_name, sqlserver.session_id, sqlserver.session_server_principal_name, sqlserver.transaction_id, sqlserver.transaction_sequence)      ),
    ADD EVENT sqlserver.server_start_stop     (ACTION        (      sqlserver.client_app_name, sqlserver.client_hostname, sqlserver.client_pid,  sqlserver.is_system, sqlserver.nt_username, sqlserver.request_id, sqlserver.server_instance_name, sqlserver.server_principal_name, sqlserver.server_principal_sid, sqlserver.session_id, sqlserver.session_server_principal_name)      ),
    ADD EVENT sqlserver.sort_warning     (ACTION        (      sqlserver.client_app_name, sqlserver.client_hostname, sqlserver.client_pid, sqlserver.database_id, sqlserver.database_name,  sqlserver.is_system, sqlserver.nt_username, sqlserver.request_id, sqlserver.server_instance_name, sqlserver.server_principal_name, sqlserver.server_principal_sid, sqlserver.session_id, sqlserver.session_resource_group_id, sqlserver.session_server_principal_name, sqlserver.transaction_id, sqlserver.transaction_sequence)      )

	ADD TARGET package0.asynchronous_file_target(
   SET filename='c:\temp\ee\ExtendedEventsStoredProcs.xel', metadatafile='c:\temp\ee\ExtendedEventsStoredProcs.xem');